//<c>   Copyright 1988-2000 by Gerry J. Danen; all rights reserved.

//<t>   Change the Video Display Mode

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_kb.h"


#define pgVERS_ "V3.12"
#define pgTITL_ "Change Video Mode"
#define pgCOPR_ "1988"


UCHAR   v_mode, v_type ;
INT16   old_mode, v_ega=FALSE, v_rows, v_cols, v_res_x, v_res_y ;
BOOL    ega_adapter=FALSE, vga_adapter=FALSE ;
INT16   ega_vga_memory=0 ;


//      Prototypes
void    change_status(void);
void    change_status_error(void);
void    do_parm(UCHAR *par);
BOOL    set_new_mode(INT16 m);
void    show_parm(void);
void    video_status(void);


void    video_status( void )
{
    STRING      crite = NULPTR ;

    VideoModeRefresh();
    cls();
    if ( vid.cols > 40 )
    {
        crite = "Copyright (c) 1988-"_THE_COPR_YEAR_", "_THE_COMPANY_NAME_ ;
        box( WHITE, vid.err_bg, 1,1, 3,vid.cols, YES, 2 );
        DspMsg( 2,4, vid.err_fg, vid.err_bg, "Video Status", NO );
        DspMsg( 2,vid.cols-2-strlen(crite), vid.err_fg, vid.err_bg, crite, NO );
    }
    else
    {
        crite = "(c) 1988-"_THE_COPR_YEAR_SHORT_", "_THE_COMPANY_NAME_ ;
        box( WHITE, vid.err_bg, 1,1, 4,vid.cols, YES, 2 );
        DspMsg( 2,15, vid.err_fg, vid.err_bg, "Video Status", NO );
        DspMsg( 3,vid.cols-strlen(crite), vid.err_fg, vid.err_bg, crite, NO );
    }
    vga_adapter = is_VGA();
    if ( ! vga_adapter )
        ega_adapter = is_EGA() ;
    ega_vga_memory  = is_EGA() ;
    if ( ega_vga_memory )
    {
        sc_msg_at( 6, 3, "%s adapter detected with %dK or more memory",
                 ( vga_adapter ? "VGA" : "EGA" ), ega_vga_memory );
    }
    sc_msg_at( 8, 3, "Monitor is displaying %d columns and %d lines", vid.cols, vid.rows );
    sc_msg_at(10, 3, "Video Display Mode is %d: ", vid.mode );
    switch ( vid.mode )
    {
        case 0 :
        case 2 :
            tty_print( "Text B/W" );
            break ;
        case 1 :
        case 3 :
            tty_print( "Text Color" );
            break ;
        case 4 :
            tty_print( "Graphics 320x200 Color" );
            break ;
        case 5 :
            tty_print( "Graphics 320x200 B/W" );
            break ;
        case 6 :
            tty_print( "Graphics 640x200 B/W" );
            break ;
        case 7 :
            tty_print( "Monochrome" );
            break ;
        case 13 :
        case 14 :
        case 15 :
        case 16 :
            tty_print( "EGA/VGA Mode" );
            break ;
        default:
            tty_printf( vid.err_fg, vid.err_bg, "Advanced Mode" );
            break ;
    }
    sc_msg_at(12, 3, "Screen I/O is " );
    switch ( vid.io_mode )
    {
        case 0 :
            tty_print( "direct to hardware" );
            break ;
        case 1 :
            tty_print( "through BIOS" );
            break ;
        default:
            tty_printf( vid.err_fg, vid.err_bg, "error: %d", vid.io_mode );
            break ;
    }
    MoveCursor( 14,3 );
}


void    change_status_error( void )
{
    tty_printf( vid.err_fg, vid.err_bg, "\nNot a legal combination of video parameters\a\n" );
}


BOOL    set_new_mode( INT16 m )
{
    if ( (m > 7) && (! is_EGA()) )
    {
        change_status_error();
        return( ERROR );
    }
    ResetVideo( m );
    switch ( m )
    {
        case 0x00 :
        case 0x01 :
        case 0x02 :
        case 0x03 :
        case 0x23 :
        case 0x33 :
            if ( v_rows == 43 && is_EGA() )
                EGA_43();
    }
    return( OK );
}


void    change_status( void )
{
    switch ( v_mode )
    {
        case 'C' :
            switch ( v_type )
            {
                case 'T' :
                    switch ( v_cols )
                    {
                        case  40 :
                            set_new_mode( 0x01 );
                            break ;
                        case  80 :
                            set_new_mode( 0x03 );
                            break ;
                        case 132 :
                            if ( v_rows == 25 || v_rows == 43 )
                                set_new_mode( 0x23 );
                            else
                            if ( v_rows == 44 )
                                set_new_mode( 0x33 );
                            else
                                change_status_error();
                            break ;
                        default :
                            change_status_error();
                    }
                    break ;
                case 'G' :
                    switch ( v_res_x )
                    {
                        case 320 :
                            if ( v_ega )
                                set_new_mode( 0x0D );
                            else
                                set_new_mode( 0x04 );
                            break ;
                        case 640 :
                            if ( v_res_y == 200 )
                                set_new_mode( 0x0E );
                            else
                                set_new_mode( 0x10 );
                            break ;
                        default :
                            change_status_error();
                    }
                    break ;
            }
            break ;
        case 'B' :
            switch ( v_type )
            {
                case 'T' :
                    switch ( v_cols )
                    {
                        case  40 :
                            set_new_mode( 0x00 );
                            break ;
                        case  80 :
                            set_new_mode( 0x02 );
                            break ;
                        default :
                            change_status_error();
                    }
                    break ;
                case 'G' :
                    switch ( v_res_x )
                    {
                        case 320 :
                            set_new_mode( 0x05 );
                            break ;
                        case 640 :
                            set_new_mode( 0x06 );
                            break ;
                        default :
                            change_status_error();
                    }
                    break ;
            }
            break ;
        case 'M' :
            switch ( v_type )
            {
                case 'T' :
                    switch ( v_cols )
                    {
                        case  80 :
                            set_new_mode( 0x07 );
                            break ;
                        case 132 :
                            if ( v_rows == 25 )
                                set_new_mode( 0x27 );
                            else
                            if ( v_rows == 44 )
                                set_new_mode( 0x37 );
                            else
                                change_status_error();
                            break ;
                        default :
                            change_status_error();
                    }
                    break ;
                case 'G' :
                    set_new_mode( 0x0F );
                    break ;
            }
            break ;
    }
}


void    do_parm( UCHAR *par )
{
    _strupr( par );
    if ( (*par == 'C') || (*par == 'B') || (*par == 'M') )
        v_mode = *par ;
    if ( (*par == 'T') || (*par == 'G') )
        v_type = *par ;
    if ( StrEq( par, "40" ) || StrEq( par, "80" ) || StrEq( par, "132" ) )
        v_cols = atoi( par );
    if ( StrEq( par, "25" ) || StrEq( par, "43" ) || StrEq( par, "44" ) )
        v_rows = atoi( par );
    if ( StrEq( par, "320" ) || StrEq( par, "640" ) )
        v_res_x = atoi( par );
    if ( StrEq( par, "200" ) || StrEq( par, "350" ) )
        v_res_y = atoi( par );
    if ( StrEq( par, "EGA" ) )
        v_ega = TRUE ;
    if ( StrEq( par, "CGA" ) )
        v_ega = FALSE ;
}


void    show_parm( void )
{
    UCHAR       *pmode, *ptype ;

    switch ( v_mode )
    {
        case 'C' :
            pmode = "Color" ;
            break ;
        case 'B' :
            pmode = "B&W" ;
            break ;
        case 'M' :
            pmode = "Mono" ;
            break ;
        default  :
            pmode = "?" ;
    }
    switch ( v_type )
    {
        case 'T' :
            ptype = "Text" ;
            break ;
        case 'G' :
            ptype = "Graphics" ;
            break ;
        default  :
            ptype = "?" ;
    }
    tty_print( "Mode %s  Type %s  ", pmode, ptype );
    if ( v_type == 'T' )
        tty_print( "%d Columns x %d Rows", v_cols, v_rows );
    else
        tty_print( "Resolution %d x %d", v_res_x, v_res_y );
    tty_print( "\n" );
}


void    main( int argc, char *argv[] )
{
    INT16       mode, reply ;

    VideoModeRefresh();

//  if ( (vid.mode == 1) || (vid.mode == 3) )
//      vid.normal_bg = BLUE ;
//  VideoModeRefresh();

    v_mode  = 'C' ;
    v_type  = 'T' ;
    v_rows  = vid.rows ;
    v_cols  = vid.cols ;
    v_res_x = v_cols * 8 ;
    v_res_y = 200 ;
    old_mode= vid.mode ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(1);
    tm_sleep_secs( 2 );

    if ( vid.mode != old_mode )
        ResetVideo( old_mode );

    if ( vid.mode > 3 && vid.mode != 7 )
    {
        printf( "Change to text mode? (Y/N) " );
        CursOn();
        mode = FALSE ;
        do  {
            reply = kb_getkey_();
            reply = toupper(reply);
            if ( reply == (INT16) 'Y' )
                mode = 1 ;
            if ( reply == (INT16) 'N' )
                mode = 2 ;
        }   while( ! mode );
        if ( mode == 2 )
        {
            printf( "NO\n" );
            gd_exit( 0, "Excecution cancelled" );
        }
        ResetVideo( 2 );
        video_status();
    }

    cls();
    switch ( old_mode )
    {
        case 0 :
        case 2 :
            v_mode  = 'B' ;
            break ;
        case 1 :
        case 3 :
            break ;
        case 5 :
        case 6 :
            v_mode  = 'B' ;
        case 4 :
            v_type  = 'G' ;
            break ;
        case 7 :
            v_mode  = 'M' ;
            break ;
        case 13:
            v_ega = TRUE ;
        case 14:
            v_type  = 'G' ;
            break ;
        case 15:
            v_mode  = 'M' ;
        case 16:
            v_type  = 'G' ;
            v_res_y = 350 ;
            break ;
        default:
            break ;
    }
    if ( argc > 1 )
    {
        tty_print( "Changing Video Mode From: " );
        show_parm();
        while ( --argc != 0 )
        {
            do_parm( *++argv );
        }
        tty_print( "\t\t    To  : " );
        show_parm();
        change_status();
        video_status();
        gd_exit( 0, "" );
    }
    video_status();
    tty_print( "Change mode? (Y/N) " );
    CursOn();
    mode = FALSE ;
    do  {
        reply = kb_getkey_();
        if ( (reply == (INT16) 'y') || (reply == (INT16) 'Y') )
            mode = 1 ;
        if ( (reply == (INT16) 'n') || (reply == (INT16) 'N') )
            mode = 2 ;
    }   while( ! mode );
    if ( mode == 2 )
    {
        tty_print( "NO\n" );
        gd_exit( 0, "" );
    }
    tty_print( "YES\n" );
    cls();
    tty_print( "Choice    Mode  Type   Cols/Rows  Resolution  Colors  Monitors\n" );
    tty_print( "    " );
    tty_print( "\n   0      Color Text     40 x 25  320 x 200    B/W    EGA & CGA" );
    tty_print( "\n   1      Color Text     40 x 25  320 x 200     16    EGA & CGA" );
    tty_print( "\n   2      Color Text     80 x 25  640 x 200    B/W    EGA & CGA" );
    tty_print( "\n   3      Color Text     80 x 25  640 x 200     16    EGA & CGA" );
    tty_print( "\n   4      Color Graphics 40 x 25  320 x 200      4    EGA & CGA" );
    tty_print( "\n   5      Color Graphics 40 x 25  320 x 200    B/W    EGA & CGA" );
    tty_print( "\n   6      Color Graphics 80 x 25  640 x 200    B/W    EGA & CGA" );
    tty_print( "\n   7      Mono  Text     80 x 25  720 x 350    B/W    EGA & Mono" );
    tty_print( "\n   8*     Color Graphics          160 x 200           PCjr" );
    tty_print( "\n   9*     Color Graphics          320 x 200           PCjr" );
    tty_print( "\n  10*     Color Graphics          640 x 200           PCjr" );
    tty_print( "\n  13      Color Graphics 40 x 25  320 x 200     16    EGA" );
    tty_print( "\n  14      Color Graphics 80 x 25  640 x 200     16    EGA" );
    tty_print( "\n  15      Mono  Graphics 80 x 25  640 x 350    B/W    EGA" );
    tty_print( "\n  16      Color Graphics 80 x 25  640 x 350     16    EGA" );
    tty_print( "\n  99      Advanced mode" );
    tty_print( "\n\n     *    = not supported\n\n          Your Choice: " );
    scanf( "%d", &mode );
    if ( InRange( mode, 8, 10 ) )
        gd_exit( 1, "PCjr not supported" );
    if ( is_EGA() )
    {
        if ( ! InRange( mode, 0, 16 ) )
        {
            cls();
            tty_print( "Advanced modes.  Select normal mode 0-7, 13-16, or from the list below:\n" );
            tty_print( "\nChoice    Mode  Type   Cols/Rows  Resolution  Colors  Monitors" );
            tty_print( "\n    " );
            tty_print( "\n  101     Color Text    132 x 25  1056 x 200    16    EGA Wonder" );
            tty_print( "\n  102     Color Text    132 x 44  1056 x 352    16    EGA Wonder" );
            tty_print( "\n  103     Mono  Text    132 x 25  1056 x 200   B/W    EGA Wonder" );
            tty_print( "\n  104     Mono  Text    132 x 44  1056 x 352   B/W    EGA Wonder" );
            tty_print( "\n   43     Any   Text    any x 43                      EGA" );
            tty_print( "\n   Your Choice: " );
            scanf( "%d", &mode );
            if ( InRange( mode, 8, 10 ) )
                gd_exit( 1, "PCjr not supported" );
            if ( (! InRange( mode,   0,  16 )) &&
                 (! InRange( mode, 101, 104 )) &&
                 (mode != 43) )
                gd_exit( 1, "Illegal mode for EGA" );
        }
    }
    else                                        //  assume CGA or Monochrome
    {
        if ( vid.adapter == 0 )
            gd_exit( 1, "Cannot change monochrome" );
        if ( ! InRange( mode, 0, 6 ) )
            gd_exit( 1, "Illegal mode for CGA" );
    }
    switch ( mode )
    {
        case 43 :
            EGA_43();
            break ;
        case 101:
            ResetVideo( 0x23 );
            break ;
        case 102:
            ResetVideo( 0x33 );
            break ;
        case 103:
            ResetVideo( 0x27 );
            break ;
        case 104:
            ResetVideo( 0x37 );
            break ;
        default :
            ResetVideo( mode );
    }
    video_status();
    gd_exit( 0, "" );
}
